// CodeGear C++ Builder
// Copyright (c) 1995, 2007 by CodeGear
// All rights reserved

// (DO NOT EDIT: machine generated header) 'Dcinternal.pas' rev: 11.00

#ifndef DcinternalHPP
#define DcinternalHPP

#pragma delphiheader begin
#pragma option push
#pragma option -w-      // All warnings off
#pragma option -Vx      // Zero-length empty class member functions
#pragma pack(push,8)
#include <System.hpp>	// Pascal unit
#include <Sysinit.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <Graphics.hpp>	// Pascal unit
#include <Registry.hpp>	// Pascal unit
#include <Inifiles.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Dcinternal
{
//-- type declarations -------------------------------------------------------
typedef __int64 TdcFileSize;

#pragma option push -b-
enum TdcScanAttribute { saNormal, saArchive, saReadOnly, saHidden, saSystem, saDirectory, saAny };
#pragma option pop

typedef Set<TdcScanAttribute, saNormal, saAny>  TdcScanAttributes;

#pragma option push -b-
enum dcInternal__1 { saveOnClose, saveOnMoveResize };
#pragma option pop

typedef Set<dcInternal__1, saveOnClose, saveOnMoveResize>  TdcRegSaverOptions;

#pragma option push -b-
enum TdcRegLocation { rCurrentUser, rLocalMachine };
#pragma option pop

#pragma option push -b-
enum TdcStorageType { useRegistry, useIniFile };
#pragma option pop

class DELPHICLASS TdcRegistrySaver;
class PASCALIMPLEMENTATION TdcRegistrySaver : public Classes::TPersistent 
{
	typedef Classes::TPersistent inherited;
	
private:
	bool FEnabled;
	AnsiString FIniFileName;
	AnsiString FIniSection;
	TdcRegSaverOptions FOptions;
	AnsiString FRegKey;
	TdcRegLocation FRegLocation;
	TdcStorageType FStorage;
	Classes::TComponent* FOwner;
	bool __fastcall IsStoreRegKey(void);
	void __fastcall SetRegKey(const AnsiString Value);
	
protected:
	virtual void __fastcall DoSaveToRegistry(Registry::TRegistry* Reg) = 0 ;
	virtual void __fastcall DoLoadFromRegistry(Registry::TRegistry* Reg) = 0 ;
	virtual void __fastcall DoSaveToIniFile(Inifiles::TIniFile* Ini) = 0 ;
	virtual void __fastcall DoLoadFromIniFile(Inifiles::TIniFile* Ini) = 0 ;
	
public:
	__fastcall virtual TdcRegistrySaver(Classes::TComponent* aOwner);
	virtual void __fastcall Save(void);
	virtual void __fastcall Load(void);
	__property Classes::TComponent* Owner = {read=FOwner};
	
__published:
	__property bool Enabled = {read=FEnabled, write=FEnabled, default=0};
	__property AnsiString IniFileName = {read=FIniFileName, write=FIniFileName};
	__property AnsiString IniSection = {read=FIniSection, write=FIniSection};
	__property TdcRegSaverOptions Options = {read=FOptions, write=FOptions, default=1};
	__property AnsiString RegKey = {read=FRegKey, write=SetRegKey, stored=IsStoreRegKey};
	__property TdcRegLocation RegLocation = {read=FRegLocation, write=FRegLocation, default=0};
	__property TdcStorageType Storage = {read=FStorage, write=FStorage, default=0};
public:
	#pragma option push -w-inl
	/* TPersistent.Destroy */ inline __fastcall virtual ~TdcRegistrySaver(void) { }
	#pragma option pop
	
};


class DELPHICLASS TdcUniqueList;
class PASCALIMPLEMENTATION TdcUniqueList : public Classes::TList 
{
	typedef Classes::TList inherited;
	
public:
	HIDESBASE int __fastcall Add(void * Item);
	HIDESBASE void __fastcall Insert(int Index, void * Item);
public:
	#pragma option push -w-inl
	/* TList.Destroy */ inline __fastcall virtual ~TdcUniqueList(void) { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* TObject.Create */ inline __fastcall TdcUniqueList(void) : Classes::TList() { }
	#pragma option pop
	
};


typedef void __fastcall (__closure *TdcObjectListItemEvent)(System::TObject* Sender, System::TObject* Item);

class DELPHICLASS TdcObjectList;
class PASCALIMPLEMENTATION TdcObjectList : public TdcUniqueList 
{
	typedef TdcUniqueList inherited;
	
private:
	bool FOwnsObjects;
	TdcObjectListItemEvent FOnAdded;
	TdcObjectListItemEvent FOnDeleted;
	Classes::TNotifyEvent FOnChanged;
	
protected:
	System::TObject* FOwner;
	virtual bool __fastcall IsCanAddItem(System::TObject* Item);
	virtual void __fastcall Notify(void * Ptr, Classes::TListNotification Action);
	virtual void __fastcall DoAdded(System::TObject* Item);
	virtual void __fastcall DoDeleted(System::TObject* Item);
	virtual void __fastcall DoChanged(void);
	virtual void __fastcall Initialize(void);
	virtual void __fastcall LoadItemFromStream(Classes::TStream* Stream);
	virtual void __fastcall SaveItemToStream(int Index, Classes::TStream* Stream);
	
public:
	__fastcall TdcObjectList(void)/* overload */;
	__fastcall TdcObjectList(bool AOwnsObjects, System::TObject* AOwner)/* overload */;
	__fastcall TdcObjectList(Classes::TStream* AStream, bool AOwnsObjects, System::TObject* AOwner)/* overload */;
	HIDESBASE int __fastcall Add(System::TObject* Item);
	HIDESBASE int __fastcall Remove(System::TObject* Item, bool ReleaseInstance = true);
	HIDESBASE void __fastcall Delete(int Index, bool ReleaseInstance = true);
	HIDESBASE int __fastcall IndexOf(System::TObject* Item);
	HIDESBASE void __fastcall Insert(int Index, System::TObject* Item);
	int __fastcall FindInstanceOf(TMetaClass* AClass, bool AExact = true, int AStartAt = 0x0);
	virtual void __fastcall LoadFromStream(Classes::TStream* Stream, bool Reset = true);
	virtual void __fastcall SaveToStream(Classes::TStream* Stream);
	__property System::TObject* Owner = {read=FOwner};
	__property bool OwnsObjects = {read=FOwnsObjects, write=FOwnsObjects, default=1};
	__property TdcObjectListItemEvent OnAdded = {read=FOnAdded, write=FOnAdded};
	__property TdcObjectListItemEvent OnDeleted = {read=FOnDeleted, write=FOnDeleted};
	__property Classes::TNotifyEvent OnChanged = {read=FOnChanged, write=FOnChanged};
public:
	#pragma option push -w-inl
	/* TList.Destroy */ inline __fastcall virtual ~TdcObjectList(void) { }
	#pragma option pop
	
};


class DELPHICLASS TdcListObject;
class PASCALIMPLEMENTATION TdcListObject : public Classes::TPersistent 
{
	typedef Classes::TPersistent inherited;
	
private:
	TdcObjectList* FOwner;
	
protected:
	virtual void __fastcall Initialize(System::TObject* AObject);
	
public:
	void *Data;
	__fastcall virtual TdcListObject(TdcObjectList* aOwner, Classes::TStream* Stream, System::TObject* AObject);
	virtual void __fastcall LoadFromStream(Classes::TStream* Stream, System::TObject* AObject = (System::TObject*)(0x0));
	virtual void __fastcall SaveToStream(Classes::TStream* Stream);
	__property TdcObjectList* Owner = {read=FOwner};
public:
	#pragma option push -w-inl
	/* TPersistent.Destroy */ inline __fastcall virtual ~TdcListObject(void) { }
	#pragma option pop
	
};


class DELPHICLASS TumdcComponent;
class PASCALIMPLEMENTATION TumdcComponent : public Classes::TComponent 
{
	typedef Classes::TComponent inherited;
	
private:
	AnsiString FAbout;
	
public:
	__fastcall virtual TumdcComponent(Classes::TComponent* aOwner);
	__property AnsiString About = {read=FAbout, write=FAbout, stored=false};
public:
	#pragma option push -w-inl
	/* TComponent.Destroy */ inline __fastcall virtual ~TumdcComponent(void) { }
	#pragma option pop
	
};


//-- var, const, procedure ---------------------------------------------------

}	/* namespace Dcinternal */
using namespace Dcinternal;
#pragma pack(pop)
#pragma option pop

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// Dcinternal
